   --      ,  
   --     ().
   --   ()   
   --
   --   [(x ,y ),(x ,y ),...,(x ,y )],
   --      1  1    2  2        j  j
   --
   --     ,   
   -- x   y , x   y ,..., x   y .
   --  1    1   2    2       j    j
   --
   --  (x,y)    (x,y)  (y,x).
   --   x   (x,"FALSE").
   --
   --   (  LISP): .. 
   --    Haskell: .. (22.01.2010) 
   ----------------------------------------------------------
   module LibGrp_1
      (addArc,listNode,neighb,neighb_1,deleteNode,addList,srchNode,
       delArc,istoks,stoks,memberList,oneRange,listSet,equalSet,str2num)
   where
   import Char
   -----------------------------------------------------------
   --   (x,y)   Graph,   
   -------------------------------------------------------------------
   addArc:: String -> String -> [(String,String)] -> [(String,String)]
   addArc x y graph | (memberList (x,y) graph) = graph
                    | True                     = (x,y) : graph
   -----------------------------------------------------------
   --  ,     Graph,
   --    ()
   ----------------------------------------
   listNode:: [(String,String)] -> [String]
   listNode graph | null graph = []
                  | True       = listSet (oneRange graph)
   ----------------------------------------------------------
   --   ,   x,  -
   --   Graph,   
   -------------------------------------------------
   neighb:: String -> [(String,String)] -> [String]
   neighb x graph | null graph          = []
                  | fst (head graph)==x &&
                    snd (head graph)=="FALSE"
                                        = []
                  | fst (head graph)==x = snd (head graph) :
                                          neighb x (tail graph)
                  | snd (head graph)==x = fst (head graph) :
                                          neighb x (tail graph)
                  | True                = neighb x (tail graph)
   ------------------------------------------------------------
   --   ,   x,  -
   --   Graph,   
   --------------------------------------------------
   neighb_1:: String -> [(String,String)] -> [String]
   neighb_1 x graph | null graph          = []
                    | fst (head graph)==x &&
                      snd (head graph)=="FALSE"
                                          = []
                    | fst (head graph)==x = snd (head graph) :
                                            neighb_1 x (tail graph)
                    | True                = neighb_1 x (tail graph)
   ----------------------------------------------------------------
   --   x   Graph,   
   -------------------------------------------------------------
   deleteNode:: String -> [(String,String)] -> [(String,String)]
   deleteNode x graph | null graph      = []
                      | fst (head graph)==x || snd (head graph)==x
                                        = deleteNode x (tail graph)
                      | True            = head graph :
                                          deleteNode x (tail graph)
   ----------------------------------------------------------------
   --    Graph ,   Node 
   -- ,    LST
   ----------------------------------------------------
   addList:: String -> [String] -> [(String,String)] ->
                                               [(String,String)]
   addList node lst graph | null lst = graph
                          | True     = addList node 
                                               (tail lst)
                                               (addArc node 
                                                       (head lst)
                                                       graph)
   ----------------------------------------------------------
   --    Graph,   , ,
   --   ,    LST;
   -- NodeLST -     Graph
   --------------------------------------------------------------
   srchNode:: [String] -> [String] -> [(String,String)] -> String
   srchNode lst nodeLst graph 
         | null lst  = ""
         | equalSet (listSet (neighb (head nodeLst) graph)) lst
                     = head nodeLst
         | True      = srchNode lst (tail nodeLst) graph
   -------------------------------------------------------
   --   (x,y)    Graph,
   --   .
   -- : . (1 , . ), 31.05.2006
   -------------------------------------------------------------------
   delArc:: String -> String -> [(String,String)] -> [(String,String)]
   delArc x y graph | null graph = []
                    | not (fst (head graph)==x &&
                           snd (head graph)==y)
                                 = head graph : delArc x y (tail graph)
                    | (not (elem x (tail (istoks graph)) ||
                            elem x (tail (stoks graph)))) &&
                      (not (elem y (tail (istoks graph)) ||
                            elem y (tail (stoks graph)))) 
                                 = (x,"FALSE"): (y,"FALSE"): 
                                   delArc x y (tail graph)
                    | (elem x (tail (istoks graph)) ||
                       elem x (tail (stoks graph))) &&
                      (not (elem y (tail (istoks graph)) ||
                            elem y (tail (stoks graph)))) 
                                 = (y,"FALSE") : delArc x y 
                                                        (tail graph)
                    | (not (elem x (tail (istoks graph)) ||
                            elem x (tail (stoks graph)))) &&
                      (elem y (tail (istoks graph)) ||
                       elem y (tail (stoks graph))) 
                                 = (x,"FALSE") : delArc x y 
                                                        (tail graph)
                    | True       = delArc x y (tail graph)
   ---------------------------------------------------------------
   --    -""   Graph
   ---------------------------------------------------------------
   istoks:: [(String,String)] -> [String]
   istoks graph | null graph = []
                | True       = fst (head graph) : 
                               istoks (tail graph)
   -----------------------------------------------------------
   --    -""   Graph
   -----------------------------------------------------------
   stoks:: [(String,String)] -> [String]
   stoks graph | null graph = []
               | True       = snd (head graph) : stoks (tail graph)
   ----------------------------------------------------------------
   --   :
   -------------------------------------------------------------
   -- ,  T,    Pair  
   --    LST  NIL -   
   ---------------------------------------------------------
   memberList:: (String,String) -> [(String,String)] -> Bool
   memberList (x,y) lst | lst==[] = False
                        | y=="FALSE" && 
                          not (assoc x lst (==)==[])
                                  = True
                        | [(x,y)]==assoc x lst (==)
                                  = True
                        | True    = memberList (x,y) (tail lst)
   -------------------------------------------------------------
   -- ,      
   -- alist ,        fst-  
   --  key   test    False.  
   --   ,    , ,  
   --     ;  -  
   ----------------------------------------------------------
   assoc:: String -> [(String,String)] ->
           (String -> String -> Bool) -> [(String,String)]
   assoc key alist test | null alist = []
                        | test (fst (head alist)) key
                                     = [head alist]
                        | True       = assoc key (tail alist) test
   ---------------------------------------------------------------
   --       
   -------------------------------------------------------
   oneRange:: [(String,String)] -> [String]
   oneRange lst | null lst = []
                | True     = [fst (head lst),snd (head lst)] ++
                             oneRange (tail lst)
   -------------------------------------------------------
   --    LST   
   -- (    )
   -----------------------------------------------
   listSet:: [String] -> [String]
   listSet lst | null lst  = []
               | elem (head lst) (tail lst)
                           = listSet (tail lst)
               | True      = head lst : listSet (tail lst)
   --------------------------------------------------------------
   --       
   --   LST1  LST2
   --------------------------------------
   equalSet:: [String] -> [String] -> Bool
   equalSet lst1 lst2 | null lst1 = null lst2
                      | elem (head lst1) lst2
                                  = equalSet (tail lst1)
                                             (filter ((head lst1)/=)
                                                     lst2)
                      | True      = False
   ---------------------------------------------------
   -- ,      
   ---------------------------------------------------
   str2num:: String -> Int
   str2num str | str=="" = error "!"
               | head str=='-'
                         = 0-sum (str2num1 (reverse (tail str)) 
                                 ((length str)-1) 1)
               | True    = sum (str2num1 (reverse str)
                                         (length str) 1)
   -----------------------------------------------------
   str2num1:: String -> Int -> Int -> [Int]
   str2num1 str n m | n==1 = [(digitToInt (head str))*m]
                    | True = (digitToInt (head str))*m : 
                             str2num1 (tail str) (n-1) (m*10)
